require "rexml/document"

def block_as_strs(element)
        result = []
        element.elements.each { |e| result.concat(dispatch(e)) }
        return result
end
def line_as_strs(element)
        values = []
        REXML::XPath.each(element,'./(text()|*)') do |n|
                v = dispatch(n)
                values << v 
        end
        return [""] if values == []
        
        num_of_lines = values.map{|v|v.length}.max
        
        
        
        values.map! do |v|
                filler = ""
                filler = v[0] if v.length == 1
                v.fill(filler,((v.length)..(num_of_lines-1)))
        end
        
        result = []
        (0..num_of_lines-1).each do |i|
                result << ""
                values.each do |v|
                        result[-1] << v[i]
                end
        end
        return result
end
def dispatch(node)
        if node.is_a? REXML::Text
                arr = Array.new()
                return arr << REXML::Text::unnormalize(node.to_s)
        elsif node.is_a? REXML::Element
                if node.name == "line"
                        return line_as_strs(node)
                elsif node.name == "block"
                        return block_as_strs(node)
                elsif node.name == "inc"
                        target = node.attributes["name"]
                        query = "//block[@name='#{target}']"
                        node = REXML::XPath.first($doc,query)
                        if node == nil
                                puts "Can't find include: "+target
                                return []
                        end
                        return dispatch(node)
                else
                        return []
                end
        end
end

def convert_file(filename,outdir="")
        file = File::open(filename)
        $doc = REXML::Document.new file
        file.close

        
        file_elements = $doc.elements.to_a("//file")
        file_elements.each do |fe|
                file = File::open(outdir+fe.attributes["name"],"w")
                strs = block_as_strs(fe)
                strs.each { |s| file.write(s+"\n") }
                file.close
        end
end

convert_file(ARGV[0])
